Subject: Re: [PATCH 2/2] e1000: remove risky prefetch on next_skb->data

From: Rick Jones <[email-masked]>
Date: Mon, 05 Jun 2006 17:16:27 -0700

Brandeburg, Jesse wrote:
> On Mon, 5 Jun 2006, Rick Jones wrote:
>>Kok, Auke wrote:
>>
>>>It was brought to our attention that the prefetches break e1000 traffic
>>>on xscale/arm architectures.  Remove them for now.  We'll let them
>>>stay in mm for a while, or find a better solution to enable.
>>
>>Out of curiousity, what breaks?
> 
> 
> Hi Rick, according to our reporter, receives break.  The prefetch (not 
> always, but sometimes) lets the processor get junk from the prefetched 
> area.  Apparently this version of arm doesn't quite do as strict 
> enforcement of bus snoops as x86, ia64, (and even pSeries!) does.

Bear with me, I'm a software guy :)  I interpret that to mean that the 
processor is basically broken?  If so, wouldn't it be the case that 
prefetch() needs to become a noop on that processor?

> This manifested with a large drop in receive peformance using TCP, 
> probably because it was retransmitting frequently.

I forget - what were the gains on the other CPUs?

rick

> Jesse